/***********************************************************************

						 -- Oyayusby Utility --

------------------------------------------------------------------------

	ްޗ / 

	Copyright (c) 2014, 2018 Kiyoto.
	This software is distributed under the MIT license.

***********************************************************************/

/* @memo ʉߋ°ٗp(ew̗F Mk-2ײނ̐ݒ°فAIMEӰސݒ۸) */

#pragma once

#include <initguid.h>

/*----------------------------------------------------------------------------*/
/* ȉADDKt̊ȩͯق`p */
DEFINE_GUID(GUID_DEVINTERFACE_KEYBOARD, 0x884b96c3, 0x56ef, 0x11d1, 0xbc, 0x8c, 0x00, 0xa0, 0xc9, 0x14, 0x05, 0xdd);

#define IOCTL_KEYBOARD_SET_INDICATORS		CTL_CODE(FILE_DEVICE_KEYBOARD, 0x0002, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_KEYBOARD_QUERY_INDICATORS		CTL_CODE(FILE_DEVICE_KEYBOARD, 0x0010, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_KEYBOARD_QUERY_IME_STATUS		CTL_CODE(FILE_DEVICE_KEYBOARD, 0x0400, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_KEYBOARD_SET_IME_STATUS		CTL_CODE(FILE_DEVICE_KEYBOARD, 0x0401, METHOD_BUFFERED, FILE_ANY_ACCESS)

/*----------------------------------------------------------------------------*/

namespace oyayusby_util_lib {

	/*----------------------------------------------------------------------------*/
	/* ȉADDKt̊ȩͯق`p */
	typedef struct _KEYBOARD_INDICATOR_PARAMETERS {

		/* ް޸׽̲ݽݽԍBײޖ̐lw肷邱 */
		/* ǂkbdhid͌ɌĂ͗l */
		USHORT UnitId;

		/* LEDݒlB`e͈ȉ */
		#define KEYBOARD_LED_INJECTED     0x8000 //Used by Terminal Server
		#define KEYBOARD_SHADOW           0x4000 //Used by Terminal Server
		#define KEYBOARD_KANA_LOCK_ON     8 // Japanese keyboard
		#define KEYBOARD_CAPS_LOCK_ON     4
		#define KEYBOARD_NUM_LOCK_ON      2
		#define KEYBOARD_SCROLL_LOCK_ON   1
		USHORT    LedFlags;

	} KEYBOARD_INDICATOR_PARAMETERS, *PKEYBOARD_INDICATOR_PARAMETERS;

	typedef struct _KEYBOARD_IME_STATUS {

		/* UnitIdcew̗F͌ĂȂAĂ₾ȂB */
		USHORT UnitId;

		/* 0IMEA1IMELȂ͖`? */
		ULONG ImeOpen;
	
		/* ImmSetConversionStatus()̑(IME_CMODE_JAPANESE)Ɠ`Ŏw肷 */
		ULONG ImeConvMode;

	} KEYBOARD_IME_STATUS, *PKEYBOARD_IME_STATUS;

	/*----------------------------------------------------------------------------*/

	/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
	/*
		޲Ǘ׽
	
		悤́AGCǊؿ̐Ԃ𐧌䂵
	*/
	public ref class KBD_CTRL {
		
		/* ޕϐ */
		public: System::String ^path;	/* ޲߽ */
		public: HANDLE handle;			/* ޲ */
		public: int unit_id;			/* ް޸׽̲ݽݽԍ */
	
		/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
		/*
			ݽ׸
		*/
		public: KBD_CTRL(std::wstring path_org, HANDLE handle_org, int unit_id_org){
			DEBUG_PRINT("Y");
			this->path = gcnew System::String(path_org.c_str());
			this->handle = handle_org;
			this->unit_id = unit_id_org;
		}

		/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
		/*
			IMEӰސݒ
		*/
		public: bool set_ime_mode(ULONG ImeOpen, ULONG ImeConvMode){
			
			KEYBOARD_IME_STATUS InputBuffer;
			ULONG DataLength = sizeof(InputBuffer);
			ULONG ReturnedLength;

			if (handle == NULL){
				return false;
			}

			InputBuffer.UnitId = unit_id;
			InputBuffer.ImeOpen = ImeOpen;
			InputBuffer.ImeConvMode = ImeConvMode;
	
			if (!DeviceIoControl(handle, IOCTL_KEYBOARD_SET_IME_STATUS, &InputBuffer, DataLength, NULL, 0, &ReturnedLength, NULL)){
				return false;
			}

			return true;
		}

		/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
		/*
			LEDݒ
		*/
		public: bool set_led(bool scroll_lock, bool num_lock, bool caps_lock, bool kana_lock){
			
			KEYBOARD_INDICATOR_PARAMETERS InputBuffer;
			ULONG DataLength = sizeof(InputBuffer);
			ULONG ReturnedLength;

			if (handle == NULL){
				return false;
			}
			
			InputBuffer.UnitId = unit_id;
			InputBuffer.LedFlags = 
				(scroll_lock ? KEYBOARD_SCROLL_LOCK_ON : 0) |
				(num_lock    ? KEYBOARD_NUM_LOCK_ON    : 0) |
				(caps_lock   ? KEYBOARD_CAPS_LOCK_ON   : 0) |
				(kana_lock   ? KEYBOARD_KANA_LOCK_ON   : 0);
	
			if (!DeviceIoControl(handle, IOCTL_KEYBOARD_SET_INDICATORS, &InputBuffer, DataLength, NULL, 0, &ReturnedLength, NULL)){
				return false;
			}

			return true;
		}

		/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
		/*
			޽׸(GCǊؿAGCǊOؿ̉)
		*/
		public: ~KBD_CTRL(){
			this->!KBD_CTRL();
		}

		/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
		/*
			̧ײ(GCǊOؿ̉)
		*/
		protected: !KBD_CTRL(){
			DEBUG_PRINT("S");
			CloseHandle(this->handle);
		}
	};

	/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
	/*
		޲񋓸׽
	
		񋓂ł̸׽𐶐邽߂̸׽
	*/
	public ref class KBD_ENUM {
	
		/* ޕϐ */
		public: System::Collections::Generic::List<KBD_CTRL ^> ^kbd;
	
		/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
		/*
			ްײނ̗(񋓸׽ ݽ׸)
		*/
		public: KBD_ENUM(void){

			int i;
	
			HDEVINFO hDevInfo;
			SP_DEVINFO_DATA dev_info;
			SP_DEVICE_INTERFACE_DATA dev_itf_data;
	
			/* ؽď */
			this->kbd = gcnew System::Collections::Generic::List<KBD_CTRL ^>;

			/* ް޸׽̲̪AݐڑĂ޲SĂ܂޲Ă𓾂 */
			hDevInfo = SetupDiGetClassDevs(&GUID_DEVINTERFACE_KEYBOARD, 0, 0, DIGCF_PRESENT | DIGCF_PROFILE | DIGCF_DEVICEINTERFACE);
			if (hDevInfo == INVALID_HANDLE_VALUE){
				goto fin;
			}
	
			dev_info.cbSize = sizeof(SP_DEVINFO_DATA);
			dev_itf_data.cbSize = sizeof(SP_DEVINFO_DATA);

			for (i = 0; ; i++) {

				TCHAR drv_name[MAX_PATH];
				DWORD dwReqSize = 0;
				PSP_DEVICE_INTERFACE_DETAIL_DATA itf_detail;
				HANDLE handle;

				/* ޲ĂuSP_DEVINFO_DATA\́v1 */
				if (SetupDiEnumDeviceInfo(hDevInfo, i, &dev_info) == FALSE){
					/* ݂ */
					break;
				}

				/* UnitID擾Bײޖ̖Ɋ܂܂ */
				/* ײޖ"{׽ײނGUID}\ݽݽԍ"̌`ŗ */
				/* : {4d36e96b-e325-11ce-bfc1-08002be10318}\0001 */
				/* āA͍ő43AoJnʒu39ځB */
				SetupDiGetDeviceRegistryProperty(hDevInfo, &dev_info, SPDRP_DRIVER, NULL, (LPBYTE)drv_name, sizeof(drv_name), NULL);
				drv_name[43] = 0;/* ی */

//				System::Diagnostics::Debug::WriteLine(gcnew System::String(drv_name));

				/* ޲ĂuSP_DEVICE_INTERFACE_DATA\́v1 */
				if (SetupDiEnumDeviceInterfaces(hDevInfo, NULL, &GUID_DEVINTERFACE_KEYBOARD, i, &dev_itf_data) == FALSE) {
					/* ݂ */
					break;
				}

				/* \̻ނ𓾂 */
				SetupDiGetDeviceInterfaceDetail(hDevInfo, &dev_itf_data, NULL, 0, &dwReqSize, NULL);

				/* 󂯎pޯ̧쐬 */
				itf_detail = (PSP_DEVICE_INTERFACE_DETAIL_DATA)(new BYTE[dwReqSize]);
				itf_detail->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);	/* Œ̻̈ */

																				/* {̎擾 */
				SetupDiGetDeviceInterfaceDetail(hDevInfo, &dev_itf_data, itf_detail, dwReqSize, NULL, NULL);

				/* ꂽް޲J */
				handle = ::CreateFile(itf_detail->DevicePath, 0, (FILE_SHARE_READ | FILE_SHARE_WRITE), NULL, OPEN_EXISTING, 0, NULL);
				if (handle != INVALID_HANDLE_VALUE) {

					/* vf̒ǉ */
					this->kbd->Add(gcnew KBD_CTRL(itf_detail->DevicePath, handle, System::Convert::ToUInt16(gcnew System::String(&(drv_name[39])), 16)));
				}

				delete[] itf_detail;
			}
		fin:
	
			SetupDiDestroyDeviceInfoList(hDevInfo);
	
		}

		/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
		/*
			޽׸(GCǊؿAGCǊOؿ̉)
		*/
		public: ~KBD_ENUM(){
			for each (KBD_CTRL ^val in kbd){
				delete val;
			}
			this->!KBD_ENUM();
		}

		/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
		/*
			̧ײ(GCǊOؿ̉)
		*/
		protected: !KBD_ENUM(){
	
		}
	};

}
